//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
//MSP430
//časť 4 - hracia kocka
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
void setup()                                        //(1) start of setup function
{
  pinMode(P2_0, OUTPUT);                            //(2.1) set port P2.0 to digital output
  pinMode(P2_1, OUTPUT);                            //(2.2) set port P2.1 to digital output
  pinMode(P2_2, OUTPUT);                            //(2.3) set port P2.2 to digital output
  pinMode(P2_3, OUTPUT);                            //(2.4) set port P2.3 to digital output
  pinMode(P2_4, OUTPUT);                            //(2.5) set port P2.4 to digital output
  pinMode(P2_5, OUTPUT);                            //(2.6) set port P2.5 to digital output
  pinMode(P1_7, OUTPUT);                            //(2.7) set port P1.7 to digital output
  
  show_test();                                      //(3) execute LED test
  
  wm_x2();                                          //(4) display not existing combination

  pinMode(P1_3, INPUT_PULLUP);                      //(5) set port P1.3 to digital input
}
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
void loop()                                        //(6) main - endless loop
{
  while(digitalRead(P1_3) == 0)                    //(7) another loop - the cube is rolling
                                                   //    until button is pressed (P1.3 = 0)
     {
        if(digitalRead(P1_3) == 0) wm_01();        //(8.1a) change the value to 1, but only if the button is still pressed
        delay(10);                                 //(8.1b) wait a bit to make the LEDs flashing
        if(digitalRead(P1_3) == 0) wm_02();        //(8.2a) change the value to 2, but only if the button is still pressed
        delay(10);                                 //(8.2b) wait a bit to make the LEDs flashing
        if(digitalRead(P1_3) == 0) wm_03();        //(8.3a) change the value to 3, but only if the button is still pressed
        delay(10);                                 //(8.3b) wait a bit to make the LEDs flashing
        if(digitalRead(P1_3) == 0) wm_04();        //(8.4a) change the value to 4, but only if the button is still pressed
        delay(10);                                 //(8.4b) wait a bit to make the LEDs flashing
        if(digitalRead(P1_3) == 0) wm_05();        //(8.5a) change the value to 5, but only if the button is still pressed
        delay(10);                                 //(8.5b) wait a bit to make the LEDs flashing
        if(digitalRead(P1_3) == 0) wm_06();        //(8.6a) change the value to 6, but only if the button is still pressed
        delay(10);                                 //(8.6b) wait a bit to make the LEDs flashing
     }
}
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
void show_test()                                   //(T-1) - Test on Start-up
{
  wm_space();                                      //(T-2) - clear the display
  digitalWrite(P2_0, 1);                           //(T-3) - switch on the P2.1 LED
  delay(200);                                      //(T-4) - wait 200ms
  digitalWrite(P2_1, 1);                           //(T-5) - switch on the P2.1 LED
  delay(200);                                      //(T-6) - wait 200ms
  digitalWrite(P2_2, 1);                           //(T-7) - switch on the P2.2 LED
  delay(200);                                      //(T-8) - wait 200ms
  digitalWrite(P2_3, 1);                           //(T-9) - switch on the P2.3 LED
  delay(200);                                      //(T-10) - wait 200ms
  digitalWrite(P2_4, 1);                           //(T-11) - switch on the P2.4 LED
  delay(200);                                      //(T-12) - wait 200ms
  digitalWrite(P2_5, 1);                           //(T-13) - switch on the P2.5 LED
  delay(200);                                      //(T-14) - wait 200ms
  digitalWrite(P1_7, 1);                           //(T-15) - switch on the P1.7 LED
  delay(200);                                      //(T-16) - wait 200ms
}
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
void wm_space()                                    //(WM-S) - switch off all the LEDs
{
  digitalWrite(P2_0, 0);
  digitalWrite(P2_1, 0);
  digitalWrite(P2_2, 0);
  digitalWrite(P2_3, 0);
  digitalWrite(P2_4, 0);
  digitalWrite(P2_5, 0);
  digitalWrite(P1_7, 0);
}
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
void wm_01()                                    //(WM-1) - show 1
{
  digitalWrite(P2_0, 0);
  digitalWrite(P2_1, 0);
  digitalWrite(P2_2, 0);
  digitalWrite(P2_3, 0);
  digitalWrite(P2_4, 0);
  digitalWrite(P2_5, 0);
  digitalWrite(P1_7, 1);
}
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
void wm_02()                                    //(WM-2) - show 2
{
  digitalWrite(P2_0, 0);
  digitalWrite(P2_1, 0);
  digitalWrite(P2_2, 1);
  digitalWrite(P2_3, 1);
  digitalWrite(P2_4, 0);
  digitalWrite(P2_5, 0);
  digitalWrite(P1_7, 0);
}
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
void wm_03()                                    //(WM-3) - show 3
{
  digitalWrite(P2_0, 0);
  digitalWrite(P2_1, 0);
  digitalWrite(P2_2, 1);
  digitalWrite(P2_3, 1);
  digitalWrite(P2_4, 0);
  digitalWrite(P2_5, 0);
  digitalWrite(P1_7, 1);
}
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
void wm_04()                                    //(WM-4) - show 4
{
  digitalWrite(P2_0, 1);
  digitalWrite(P2_1, 0);
  digitalWrite(P2_2, 1);
  digitalWrite(P2_3, 1);
  digitalWrite(P2_4, 0);
  digitalWrite(P2_5, 1);
  digitalWrite(P1_7, 0);
}
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
void wm_05()                                    //(WM-5) - show 5
{
  digitalWrite(P2_0, 1);
  digitalWrite(P2_1, 0);
  digitalWrite(P2_2, 1);
  digitalWrite(P2_3, 1);
  digitalWrite(P2_4, 0);
  digitalWrite(P2_5, 1);
  digitalWrite(P1_7, 1);
}
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
void wm_06()                                    //(WM-6) - show 6
{
  digitalWrite(P2_0, 1);
  digitalWrite(P2_1, 1);
  digitalWrite(P2_2, 1);
  digitalWrite(P2_3, 1);
  digitalWrite(P2_4, 1);
  digitalWrite(P2_5, 1);
  digitalWrite(P1_7, 0);
}
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
void wm_x2()                                    //(WM-X2) - show strange 2
{
  digitalWrite(P2_0, 0);
  digitalWrite(P2_1, 1);
  digitalWrite(P2_2, 0);
  digitalWrite(P2_3, 0);
  digitalWrite(P2_4, 1);
  digitalWrite(P2_5, 0);
  digitalWrite(P1_7, 0);
}
//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------
